// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at https://mozilla.org/MPL/2.0/.
a#ryax-return(routerLink="/workflow/{{workflowId}}", nz-button, [nzGhost]="true", nzType="default")
  i(nz-icon, nzType="arrow-left", nzTheme="outline")
  | Workflow description

h1 Studio

#soap-wf-head
  #soap-name-edit
    ng-container(*ngIf="!editWorkflowName && !(builderFacade.workflowNameLoading$ | async) else nameEditor")
      h2 {{ (builderFacade.workflowName$ | async) || "My first workflow" }}
      button(nz-button, nzType="link", nzSize="small", (click)="startEdit()")
        i(nz-icon, nzType="edit", nzTheme="outline")
    ng-template(#nameEditor)
      nz-spin([nzSpinning]="builderFacade.workflowNameLoading$ | async")
        input(#ryaxTitleEdit, nz-input, placeholder="My first workflow", [(ngModel)]="workflowNameInput", nzBorderless,
          (keyup.enter)="validate()", autofocus, (focusout)="validate()")
        button(nz-button, nzType="primary", (click)="validate()") OK
  #soap-deploy
    p Last save {{ builderFacade.lastSave$ | async | dateTimeToJsDate | timeAgo }}
    button(nz-button, nzType="default", (click)="openModal = true") Select results
    button(nz-button, nzType="primary", [nzDanger]="!(builderFacade.deployable$ | async)", (click)="deploy()",
      nz-tooltip, [nzTooltipTitle]="!(builderFacade.deployable$ | async) ? studioErrors : undefined") Deploy

#soap-wf-config
  section
    ol(cdkDropList, (cdkDropListDropped)="drop($event)", [cdkDropListSortPredicate]="sortPredicate")
      li(*ngFor="let step of builderFacade.workflow$ | async; let i = index, trackBy: moduleCompare")
        nz-card(
          [nzBodyStyle]="{ padding: '0 8px 0 0', display: 'flex', 'align-items': 'center' }",
          (click)="openConfig(i)", cdkDrag, [cdkDragData]="i!", [cdkDragDisabled]="isDisabled(isAllSet$ | async, builderFacade.workflow$ | async, i)",
          [class.soap-active]="(builderFacade.currentIndex$ | async) === i"
        )
          .ryax-module-icon
            img([src]="'/api/studio/static/logo/' + step.panels[0].originalValue?.definitionId")
          .soap-step-content
            p.soap-step-title {{ step.name }}
              span {{ step.panels[0].originalValue?.version }}
            p.soap-step-description(*ngIf="step.panels[0].originalValue")
              ng-container(*ngIf="modulesDescriptions$ | async as description")
                | {{ description[i] }}
            i(*ngIf="step.status !== 'READY'", nz-icon, nzType="warning", nzTheme="twotone", nzTwotoneColor="#FFC966")
    #add-step
      nz-card((click)="builderFacade.addStep()", [class.ryax-disable]="isAllSet$ | async")
        i(nz-icon, nzType="plus", nzTheme="outline")
        | Add an action

  nz-spin([nzSpinning]="configLoading$ | async")
    ryax-config-panel

ryax-result-modal([(isVisible)]="openModal")

ng-template(#studioErrors)
  #ryax-error-tooltip
    p This workflow can't be deployed because:
    ul
      li(*ngFor="let error of studioErrors$ | async") {{ error.error }}
